#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

#include "ledMap.h"

#define GPIO_BASE	(0x20000000 + 0x200000)
#define BLOCK_SIZE	4096

// GPIOmmap𐶐
//  ߂lFNULL͐s
//          NULLȊOGPIOmmap|C^
volatile unsigned int *mmapGpioStartup(void) {
	int fd;
	void *pMmap;

	fd = open("/dev/mem", O_RDWR | O_SYNC);
	if (fd == -1) {
		perror("open()");
		return NULL;
	}
	
	pMmap = mmap(NULL, BLOCK_SIZE,
		PROT_READ | PROT_WRITE, MAP_SHARED,
		fd, GPIO_BASE);
	if (pMmap == MAP_FAILED) {
		perror("mmap()");
		close(fd);
		return NULL;
	}
	close(fd);
	
	return pMmap;
}

// GPIOmmap㏈
void mmapGpioCleanup(volatile unsigned int *pGpio) {
	munmap((void *)pGpio, BLOCK_SIZE);
}

// GPIŐ@\ݒ肷
//  OUT_MODE:o͐ݒ
//  IN_MODE:͐ݒ
void gpFsel(volatile unsigned int *pGpio,
					unsigned int pin,
					unsigned int mode) {
	const unsigned int GPFSEL = 0;
	
	unsigned int index = GPFSEL + pin / 10;
	unsigned int mask = ~(7 << ((pin % 10) * 3));
	pGpio[index] &= mask;
	pGpio[index] |= mode << ((pin % 10) * 3);
}

// o͂ɐݒ肵ĂꍇGPIO1o͂
void gpSet(volatile unsigned int *pGpio,
					unsigned int pin) {
	const unsigned int GPSET = 7;

	unsigned int index = GPSET + pin / 32;
	pGpio[index] = 1 << (pin % 32);
}

// o͂ɐݒ肵ĂꍇGPIO0o͂
void gpClr(volatile unsigned int *pGpio,
					unsigned int pin) {
	const unsigned int GPCLR = 10;

	unsigned int index = GPCLR + pin / 32;
	pGpio[index] = 1 << (pin % 32);
}

// ͂ɐݒ肵ĂꍇGPIOǂݍ
unsigned int gpLev(volatile unsigned int *pGpio,
					unsigned int pin) {
	const unsigned int GPLEV = 13;

	unsigned int index = GPLEV + pin / 32;
	if ((pGpio[index] & (1 << (pin % 32))) != 0) {
		return 1;
	}
	return 0;
}
